<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="UTF-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <link rel="stylesheet" href="css/styles.css">
  <title>Files' Events Manager</title>
  <script src="js/libs/modernizr-2.6.2/modernizr.min.js"></script>
  <script src="js/libs/jquery-1.9.0/jquery.min.js"></script>
  <script type="text/javascript">
    $(document).ready(function() {
      var file = null;
      var reader = null;

      if (!Modernizr.draganddrop && !window.FileList)
        alert("Your browser dosen't support the API File and Drang & Drop")

      $("#file").change(fileManager);
      $("#startReading").click(startReading);
      $("#stopReading").click(stopReading);

      function restartValues() {
        $("#progress").empty();
        $("#reading").text(0);
        $("#progressbar").val(0);
      }

      function fileManager(e) {
        restartValues();
        file = e.target.files[0];
        $("#filename").html(file.name + ", <b>Size:</b> " + file.size);
      }

      function startReading(e) {
        restartValues();
        if (file != null) {
          reader = new FileReader(e);
          
          // Onload start event
          reader.onloadstart = function(e) {
            $("#progress").append("<p>Reading file started (onloadstart)</p>");
          };
          
          // Onload end event
          reader.onloadend = function(e) {
            $("#progress").append("<p>Reading file was finished (onloadend)</p>");
          };
          
          // Onload event
          reader.onload = function(e) {
            $("#counter").append("<p>Reading file: 100% complete</p>");
            $("#progress").append("<p>Reading file was completed (onload)</p>");
          };
          
          // Onprogress event
          reader.onprogress = function(e) {
            if (e.lengthComputable) {
              var calculate = Math.round(e.loaded / e.total * 100);
              $("#reading").text(calculate + "%");
              $("#progressbar").val(calculate);
            }
          };
          
          // Onerror event
          reader.onerror = function(e) {
            $("#progress").append("<p>Error has happened (onerror)</p>");
          };
          
          // Onabort event
          reader.onabort = function(e) {
            $("#progress").append("<p>The reading was aborted (onabort)</p>");
          };

          // File reading
          reader.readAsBinaryString(file);

        } else 
        alert("You have to select a file")
      }

      function stopReading(e) {
        if (reader) 
          reader.abort();
      }

    });
  </script>
</head>
<body>
  <header>
    <h1>Files' Events Manager</h1>
  </header>
  <section>
    <form action="">
      <label for="file">Select a file:</label>
      <input type="file" name="file" id="file">
    </form>

    <p><b>Filename:</b> <span id="filename"></span></p>
    <p>Read file's content:</p>
    <button id="startReading">Start Reading</button>
    <button id="stopReading">Stop Reading</button>
    <p>Reading progress: <span id="reading"></span></p>
    <progress id="progressbar" value="0" max="100"></progress>
    <div id="progress"></div>
  </section>
</body>